<?php

namespace jrosset\CliProgram;

use jrosset\CliProgram\Monolog\TMonologApplication;
use jrosset\ExtendedMonolog\LogDirectoryHandler;

/**
 * An application with a {@see LogDirectoryHandler Monolog log directory} for each command
 */
class ApplicationWithCommandMonolog extends ApplicationWithCommandOutputInterface {
    use TMonologApplication;

    /**
     * Initialization
     *
     * @param string $logMainDirectory The main log directory for Monolog: on subdirectory by command
     * @param string $name             The application name
     * @param string $version          The application version
     */
    public function __construct (string $logMainDirectory, string $name = 'UNKNOWN', string $version = 'UNKNOWN') {
        parent::__construct($name, $version);
        $this->setLogMainDirectory($logMainDirectory);
    }
}