<?php

namespace jrosset\CliProgram\Monolog;

use jrosset\CliProgram\Output\OutputWithLogger;
use Monolog\Level;
use Monolog\Logger;
use Psr\Log\LoggerInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * A generic output interface with a {@see LoggerInterface Monolog Logger}
 *
 * @implements OutputWithLogger<Logger>
 */
class ConsoleOutputWithMonolog extends OutputWithLogger {
    /**
     * @inheritDoc
     */
    protected function getLoggerLevelFromVerbosity (int $verbosity): Level {
        if ($verbosity <= OutputInterface::VERBOSITY_QUIET) {
            return Level::Error;
        }
        elseif ($verbosity <= OutputInterface::VERBOSITY_NORMAL) {
            return Level::Notice;
        }
        elseif ($verbosity <= OutputInterface::VERBOSITY_VERBOSE) {
            return Level::Info;
        }
        elseif ($verbosity <= OutputInterface::VERBOSITY_VERY_VERBOSE) {
            return Level::Info;
        }
        elseif ($verbosity <= OutputInterface::VERBOSITY_DEBUG) {
            return Level::Debug;
        }
        else {
            return Level::Notice;
        }
    }
}