<?php
/** @noinspection PhpMissingFieldTypeInspection */

namespace jrosset\CliProgram\Validation\Validators;

/**
 * Implementation for an internal "value"
 *
 * Call {@see self::setValue()} to set the value
 *
 * @template TValue
 * @template-implements IValidator<TValue>
 */
trait TInternalValueValidator {
    /**
     * @var TValue|null The current value, after
     */
    private $value = null;

    /**
     * Get the value, after it's validation
     *
     * @return TValue|null The value
     */
    public function getValue () {
        return $this->value;
    }
    /**
     * Set the value
     *
     * @param TValue $value The value (after it's validation)
     *
     * @return $this
     */
    protected function setValue ($value): static {
        $this->value = $value;
        return $this;
    }
}